﻿var channel = new Array();
channel[0] = {id:"BBCWrld", title:"BBC World Service", webLink:"http://www.bbc.co.uk/worldservice", link:"http://www.bbc.co.uk/worldservice/meta/tx/nb/live_news_au_nb.asx",rplink:"http://www.bbc.co.uk/worldservice/meta/tx/nb/live_infent_au_nb.ram",wmplink:"http://www.bbc.co.uk/worldservice/meta/tx/nb/live_infent_au_nb.asx",image:"channels\\BBCWrld.png", desc:"International news, analysis and information from the BBC World Service."};
channel[1] = {id:"BBCROne", title:"BBC Radio 1", webLink:"http://www.bbc.co.uk/radio1", link:"http://www.bbc.co.uk/radio1/wm_asx/aod/radio1.asx", rplink:"http://www.bbc.co.uk/radio1/realaudio/media/r1live.ram",wmplink:"",image:"channels\\BBCROne.png", desc:"BBC Radio 1 - youth oriented, mostly contemporary pop music (including Top 40 singles), plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[2] = {id:"BBCRTwo", title:"BBC Radio 2", webLink:"http://www.bbc.co.uk/radio2", link:"http://www.bbc.co.uk/radio2/wm_asx/aod/radio2.asx", rplink:"http://www.bbc.co.uk/worldservice/meta/tx/nb/live_news_au_nb.ram",wmplink:"",image:"channels\\BBCRTwo.png", desc:"BBC Radio 2 - adult oriented entertainment, wide range of music - especially adult contemporary and middle of the road, also talk, comedy, plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[3] = {id:"BBCRThree", title:"BBC Radio 3", webLink:"http://www.bbc.co.uk/radio3", link:"http://www.bbc.co.uk/radio3/wm_asx/aod/radio3.asx", rplink:"http://www.bbc.co.uk/radio3/ram/r3g2.ram",wmplink:"",image:"channels\\BBCRThree.png", desc:"BBC Radio 3 - arts and high culture, special-interest music (classical, jazz, world music), plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[4] = {id:"BBCRFour", title:"BBC Radio 4", webLink:"http://www.bbc.co.uk/radio4", link:"http://www.bbc.co.uk/radio4/wm_asx/aod/radio4.asx", rplink:"http://www.bbc.co.uk/radio4/realplayer/media/fmg2.ram",wmplink:"",image:"channels\\BBCRFour.png", desc:"BBC Radio 4 - news, current affairs, arts, original in-house drama, original in-house first-run comedy, science, books and religion."};
channel[5] = {id:"BBCRFiveL", title:"BBC 5 Live", webLink:"http://www.bbc.co.uk/fivelive", link:"http://www.bbc.co.uk/fivelive/live/live_int.asx",rplink:"http://www.bbc.co.uk/fivelive/live/surestream_int.ram",wmplink:"http://www.bbc.co.uk/fivelive/live/live_int.asx", image:"channels\\BBCRFiveL.png", desc:"BBC Radio Five Live is the BBC's radio service providing live BBC News, phone-ins, and sports commentaries. It is the principal radio station covering sport in the United Kingdom, broadcasting virtually all major sports events staged in the UK or involving British competitors."};
channel[6] = {id:"BBCSixMU", title:"BBC 6 Music", webLink:"http://www.bbc.co.uk/6music", link:"http://www.bbc.co.uk/6music/ram/6music_hi.asx", rplink:"http://www.bbc.co.uk/6music/ram/dsatg2.ram",wmplink:"http://www.bbc.co.uk/6music/ram/6music.asx",image:"channels\\BBCSixMU.png", desc:"BBC 6 Music - rock, funk, punk and reggae, plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[7] = {id:"BBCSeven", title:"BBC 7", webLink:"http://www.bbc.co.uk/bbc7", link:"http://www.bbc.co.uk/bbc7/realplayer/bbc7_hi.asx", rplink:"http://www.bbc.co.uk/bbc7/realplayer/dsatg2.ram",wmplink:"http://www.bbc.co.uk/bbc7/realplayer/bbc7.asx",image:"channels\\BBCSeven.png", desc:"BBC 7 - classic comedy, drama, books, science fiction, fantasy and children's programmes."};
channel[8] = {id:"BBCRFiveX", title:"Five Live Sports Extra", webLink:"http://www.bbc.co.uk/fivelive/sportsextra", link:"http://www.bbc.co.uk/fivelive/live/live_sportsextra_int.asx", rplink:"http://www.bbc.co.uk/fivelive/live/surestream_sportsextra_int.ram",wmplink:"http://www.bbc.co.uk/fivelive/live/live_sportsextra_int.asx",image:"channels\\BBCRFiveX.png", desc:"Sports Extra was set up by the team behind Five Live to bring you more sporting action. It's as simple as that. The station offers additional commentaries from the FA Barclays Premiership, Coca Cola League, Scottish Premier League and cup football - plus cricket, rugby, Formula One, tennis and golf."};
channel[9] = {id:"BBCAsian", title:"BBC Asian Network", webLink:"http://www.bbc.co.uk/asiannetwork", link:"http://www.bbc.co.uk/asiannetwork/rams/asiannet_hi.asx", rplink:"http://www.bbc.co.uk/asiannetwork/rams/asiannetwork.ram",wmplink:"http://www.bbc.co.uk/asiannetwork/rams/asiannet.asx",image:"channels\\BBCAsian.png", desc:"The BBC Asian Network is a BBC national radio station orientated towards British Asian life, culture and music in the UK and other topics from a British Asian perspective aimed at the under 35's from that community but aiming for a broader appeal among all interested in British Asian life whether Asian or not regardless of age."};
//channel[10] = {id:"OneXtra", title:"1Xtra", webLink:"http://www.bbc.co.uk/1xtra", link:"http://www.bbc.co.uk/1xtra/realmedia/1xtra.asx", rplink:"http://www.bbc.co.uk/1xtra/realmedia/1xtralive.ram",wmplink:"http://www.bbc.co.uk/1xtra/realmedia/1xtra.asx",image:"channels\\OneXtra.png", desc:"BBC 1Xtra - new urban and black music, plus news, original in-house live music sessions, original live music concerts & music documentaries."};


var wmp = WMPEmbed.object;

var results;
var Interval = 1*60*60*1000;// during one hour 
var DIFFTIME = 0;
var PRGM_START=0;
var RUNNING_NO = 0;
var CHANNEL_NO = 0;
var ANIMATE_COUNTER = 0;
var INDICATOR_COUNTER = 0;

//Get the BCC Server time
function synchronizeGMTtime(){
	
	Requesttest = new XMLHttpRequest();
	Requesttest.open( "GET", "http://www.seiko-precision.com/js/time.php", true );
	var start = (new Date()).getTime();
	Requesttest.onreadystatechange = onResponse;
  // Start the download
  try {
    Requesttest.send();
  }
  catch ( e ) {
    // Catch errors sending the request
		debug.trace( "Time Server No Responding" );
		DIFFTIME = 0;
    Requesttest = null;
  }
	
  function onResponse() {
    // Verify that the download completed
    if ( Requesttest.readyState != 4 ){
      return ;
		}
    // Verify that the download was successful
    if ( Requesttest.status != 200 ) {
      debug.trace( "Time Server No Responding" );
      Requesttest = null;
      return ;
    }
	var end = new Date().getTime();
	var nowGMTtime = new Date(Requesttest.responseText).getTime();
	DIFFTIME = nowGMTtime - start - (end - start)/2;
	return;
}
}

function onupdateservertime(){
	var now = (new Date()).getTime();
	now = new Date( DIFFTIME + now);
	date.innerText =now.toGMTString();
}
// Set the default for first run, other wise load the user selected option
function SetDefaultOptions() {
	synchronizeGMTtime();
  if ( getStation() == "") {
    // if nothing is set then set channel 1 as the default
    setStation(RUNNING_NO );
    getSchedule( channel[RUNNING_NO].id );
    updateStaticInfo( RUNNING_NO );
  }
  //else {  // otherwise load the user last played channel
  //  var _station = getStation();
  //  getSchedule( channel[_station].id );
  //  updateStaticInfo( _station );
  //}
}

// set user selected radio station
function setStation( station ) {
  options.PutValue( "stationNumber", station );
}

// returns user prefered radio station
function getStation() {
  return options.GetValue( "stationNumber" );
}

// set player status, like playing or stopped
function setPlayerStatus( status ) {
  options.PutValue( "playerStatus", status );
}

// returns player status
function getPlayerStatus() {
  return options.GetValue( "playerStatus" );
}

function updateCheck() {
  getSchedule( channel[RUNNING_NO].id );
  updateStaticInfo( RUNNING_NO );
}

function updateStaticInfo( CHANNEL_NO ) {
	var index = channel[CHANNEL_NO];
	channelImage.src = index.image;
	channelLink.tooltip = index.desc;
	channelLink.href = index.webLink;
	runningplayerLink.href = index.wmplink;
	pendingplayerLink.href = index.rplink;
	wmp.URL = index.link;
}
function updatestationinfo(){
		var now = (new Date()).getTime();
		now = new Date( DIFFTIME + now);
		if(results==null)
			getSchedule( channel[RUNNING_NO].id );
		if(results){
		var duration = results[0].duration;
		var start = results[0].start;
		var hours = (now.getUTCHours()-parseInt(start.substr(0,2)))*60*60*1000;
		var minutes = (now.getMinutes()-parseInt(start.substr(3,2)))*60*1000;
		if((hours+minutes)>=duration)
			updateCheck();
	}
}
function updateText() {
	if(results==null)
		getSchedule( channel[RUNNING_NO].id );
	if(results){
  nowTitle.innerText = results[0].title;
  nowTitle.tooltip = results[0].title;
	nowTime.innerText = results[0].start;
  nowTime.tooltip = results[0].start;
  nowSynopsis.innerText = results[0].synopsis;
  nowSynopsis.tooltip = results[0].synopsis;
}
}

function runningindicatorAdm()	{
	if ( INDICATOR_COUNTER == 11 )
		INDICATOR_COUNTER = 0;
	else
		INDICATOR_COUNTER = INDICATOR_COUNTER + 1;

	runningindicator.src = "indicator\\indicator_large_" + INDICATOR_COUNTER + ".png";
}

function radarAdm()	{
	if ( ANIMATE_COUNTER == 4 )
		ANIMATE_COUNTER = 0;
	else
		ANIMATE_COUNTER = ANIMATE_COUNTER + 1;
	
	radar.src = "radar\\radar" + ANIMATE_COUNTER + ".png";
}

function displayStatus() {
	if( wmp.playState == 0 ) {
		status.innerText = "Undefined";
    wmp.controls.play();
  }
	else if( wmp.playState == 1 )
		status.innerText = "Stopped";
	else if( wmp.playState == 2 )
		status.innerText = "Paused";
	else if( wmp.playState == 3 )
		status.innerText = "Playing";
	else if( wmp.playState == 4 )
		status.innerText = "ScanForward";
	else if( wmp.playState == 5 )
		status.innerText = "ScanReverse";
	else if( wmp.playState == 6 )
		status.innerText = "Buffering";
	else if( wmp.playState == 7 )
		status.innerText = "Waiting";
	else if( wmp.playState == 8 )
		status.innerText = "MediaEnded";
	else if( wmp.playState == 9 ) {
		status.innerText = "Transitioning";
    wmp.controls.play();
  }
	else if( wmp.playState == 10 ) {
		status.innerText = "Ready";
    wmp.controls.play();
  }
	else if( wmp.playState == 11 )
		status.innerText = "Reconnecting";
}

// Request the schedule for the current channel using the BBC Web API
function getSchedule( cURL ) {
	var API_URL = "http://www0.rdthdo.bbc.co.uk/cgi-perl/api/query.pl?";
  var feedRequest = new XMLHttpRequest();
	var now = new Date(new Date().getTime()+Interval);
  try {
    var dMonth = now.getUTCMonth();
    if( dMonth < 10 )
      dMonth = "0" + dMonth;
    var dDate = now.getUTCDate();
    if( dDate < 10 )
      dDate = "0" + dDate;
    var hHour = now.getUTCHours();
    if( hHour < 10 )
      hHour = "0" + hHour;
    var hMin = now.getUTCMinutes();
    if( hMin < 10 )
      hMin = "0" + hMin;
    var gmtTime = now.getUTCFullYear() + "-" + ( now.getUTCMonth() + 1 ) + "-" + dDate + "T" + hHour + ":" + hMin + ":00" + "Z"; 
    var url = API_URL + "method=bbc.schedule.getProgrammes&channel_id=" + cURL + "&end=" + gmtTime + "&limit=1&detail=schedule" ;
    feedRequest.open( "GET", url, true );
  } 
  catch ( e ) {
    // Catch invalid URLs
    feedRequest = null;
		return;
  }
  
  // Set the callback for when the downloading is completed (or failed)
  feedRequest.onreadystatechange = onFeedLoad;
  // Start the download
  try {
    feedRequest.send();
  }
  catch ( e ) {
    // Catch errors sending the request
    feedRequest = null;
    return;
  }

  function onFeedLoad() {
    // Verify that the download completed
    if ( feedRequest.readyState != 4 )
      return;

    // Verify that the download was successful
    if ( feedRequest.status != 200 ) {
      debug.trace( "download failed" );
      feedRequest = null;
      return;
    }

    var doc = new DOMDocument();
    doc.loadXML( feedRequest.responseText );
    var elem = doc.getElementsByTagName( "programme" );
    results = [];
    var title, synopsis, start,duration;
    if ( elem != null && elem.length > 0 ) {
      for ( var z = 0; z < elem.length; z++ ) {        
        title = elem[z].getAttribute( "title" );
        for ( var node = elem[z].firstChild; node != null; node = node.nextSibling ) {
          if ( node.nodeName == "synopsis" ) {
            try {
              synopsis = node.firstChild.nodeValue;
            }            	
            catch ( e ) {
							debug.trace("BBC Service limited...");
              synopsis = "error";
            }
          }
          if ( node.nodeName == "start" ) {
            try {
              start = node.firstChild.nodeValue;
              start = convertDate( start );
            }            	
            catch ( e ) {
              start = "";
            }
          }
          if ( node.nodeName == "duration" ) {
            try {
              duration = node.firstChild.nodeValue;
							duration = parseInt(duration.substr(0,2))*60*60*1000+parseInt(duration.substr(3,2))*60*1000;
            }            	
            catch ( e ) {
              duration = "";
            }
          }
          results[z] = {synopsis:synopsis, title:title, start:start, duration:duration};
        }
      }
    }
    feedRequest = null;
    updateText();
  }
}

// Formats date standard string into human-readable form
// e.g. 2007-07-11T22:40:00Z
function convertDate( str ) {
	var pos = str.indexOf("T");

  return str.substr( pos+1, 5);
}

function view_onOpen() {
  SetDefaultOptions();
	// timers
	view.setInterval( synchronizeGMTtime,10*1000*60);
  view.setInterval( updatestationinfo, 1000 * 60 );
  view.setInterval( onupdateservertime, 1000 );
  view.setInterval( runningindicatorAdm, 200 );
  view.setInterval( radarAdm, 500 );
}

function lanchplayer(){
	wmp.controls.stop();
}

function channel_onclick() {
	channellist.visible=true;
	channellist.selectedIndex = RUNNING_NO;
}

function stationlist_onchange() {
// React to the user selecting a listitem.
  RUNNING_NO = channellist.selectedIndex;
	channellist.visible = false;
	setStation(RUNNING_NO );
	updateCheck();
}
